// G`֐
unit UnitGraph;

interface

uses
   Graphics, UnitClip, UnitGVar ;

procedure G_CLS(C:TCanvas;x1,y1,x2,y2:integer) ;
procedure GRB_LINE(C:TCanvas;rx1,ry1,rx2,ry2:Integer);
procedure GRB_BOX(C:TCanvas;rx1,ry1,rx2,ry2:Integer);

procedure GL_LINE(C:TCanvas;x1,y1,x2,y2:double) ;

procedure GL_PAPERFRAME(C:TCanvas) ;
procedure GL_ALLDAT(C:TCanvas) ;

implementation

// ʂNA
procedure G_CLS(C:TCanvas;x1,y1,x2,y2:integer) ;
begin
   with C do begin
      with Pen do begin
         Mode  := pmCopy ;
         Color := clWhite;
         Style := psSolid;
         Width := 1;
      end;
      with Brush do begin
         Color := clWhite;
         Style := bsSolid;
      end;
      Rectangle(x1,y1,x2,y2);
   end;
end;

// o[oh`
procedure GRB_LINE(C:TCanvas;rx1,ry1,rx2,ry2:Integer);
begin
   with C do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      MoveTo(rx1,ry1);
      LineTo(rx2,ry2);
   end;
end;

// o[oh``
procedure GRB_BOX(C:TCanvas;rx1,ry1,rx2,ry2:Integer);
begin
   with C do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      Brush.Style := bsClear ;
      Rectangle(rx1,ry1,rx2,ry2);
   end;
end;

// ========== ========== ==========

// [mm]}
procedure GL_LINE(C:TCanvas;x1,y1,x2,y2:double) ;
var
   i : integer ;
   wx1,wy1,wx2,wy2 : Double ;
   ax1,ay1,ax2,ay2 : integer ;
begin
   wx1 := x1 ;    wy1 := y1 ;
   wx2 := x2 ;    wy2 := y2 ;
   i := ClipLine(wx1,wy1,wx2,wy2,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i < 2) then begin
      ax1 := Round( (wx1 - WD_x1 ) * MM_dot );
      ay1 := Round(-(wy1 - WD_y2 ) * MM_dot );
      ax2 := Round( (wx2 - WD_x1 ) * MM_dot );
      ay2 := Round(-(wy2 - WD_y2 ) * MM_dot );
      C.MoveTo(ax1,ay1);
      C.LineTo(ax2,ay2);
   end;
end;

// ========== ========== ==========

// pg}
procedure GL_PAPERFRAME(C:TCanvas) ;
var
   x1,y1,x2,y2 : Double ;
   i : integer ;
   ax1,ay1 : Integer ;
begin
   C.Pen.Mode  := pmCopy ;
   C.Pen.Color := clBlue ;
   C.Pen.Width := 0 ;
   C.Pen.Style := psSolid;

   x1 := -PA_x/2 ;  y1 := -PA_y/2 ;
   x2 :=  PA_x/2 ;  y2 := -PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   x1 := -PA_x/2 ;  y1 :=  PA_y/2 ;
   x2 :=  PA_x/2 ;  y2 :=  PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   x1 := -PA_x/2 ;  y1 := -PA_y/2 ;
   x2 := -PA_x/2 ;  y2 :=  PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   x1 :=  PA_x/2 ;  y1 := -PA_y/2 ;
   x2 :=  PA_x/2 ;  y2 :=  PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   // _
   i := ClipPoint(0.0,0.0,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 0) then begin
      ax1 := Round( ( 0.0 - WD_x1 ) * MM_dot );
      ay1 := Round(-( 0.0 - WD_y2 ) * MM_dot );
      with C do begin
         Pen.Color := clRed ;
         MoveTo(ax1-5,ay1);   LineTo(ax1+6,ay1);
         MoveTo(ax1,ay1-5);   LineTo(ax1,ay1+6);
      end;
   end;
end;

// Svf}
procedure GL_ALLDAT(C:TCanvas) ;
var
   i,j : integer ;
   wx1,wy1,wx2,wy2 : Double ;
   k,k1,k2,kc,kl : integer ;
begin
   with C do begin
      Pen.Mode  := pmCopy ;
      Pen.Color := clBlack ;
      for k:=0 to LayTblN-1 do begin
         if (LayTbl[k].cnt = 0) then continue;  // vf=0͎̎̃C
         if not(LayTbl[k].dsp)  then continue;  // Display ͎̃C
         for i:=0 to Dat_N-1 do begin
            if (LayTbl[k].no = Dat[i].lay) then begin
               k1 := LayTbl[k].dc ; // CF
               k2 := LayTbl[k].dl ; // C
               // C
               if (Dat[i].col <> -1) then k1 := Dat[i].col ;   // CFł͂Ȃ
               if (Dat[i].lin <> -1) then k2 := Dat[i].lin ;   // Cł͂Ȃ
               // F
               kc := 0 ;
               if (k1 >= 0) then begin
                  if (k1 <= ColTblN) then kc := ColTbl[k1].val;
               end
               else begin
                  k1 := Abs(k1) - 2 ;
                  if (k1 >= 0)and(k1 <= 256*256*256-1) then kc := k1;
               end;
               // 
               kl := 0 ;
               for j:=0 to LinTblN-1 do begin
                  if (LinTbl[j].no = k2) then begin
                     kl := LinTbl[j].val;
                     break;
                  end;
               end;
               //
               Pen.Color := kc ;
               Pen.Style := psSolid ;
               Pen.Width := 10 ;
               Case(kl)of
               1: Pen.Style := psDash;
               2: Pen.Style := psDot;
               3: Pen.Style := psDashDot;
               4: Pen.Style := psDashDotDot;
               end;
               wx1 := Dat[i].x1 *LayTbl[k].sc;
               wy1 := Dat[i].y1 *LayTbl[k].sc;
               wx2 := Dat[i].x2 *LayTbl[k].sc;
               wy2 := Dat[i].y2 *LayTbl[k].sc;
               GL_LINE(C,wx1,wy1,wx2,wy2);
            end;
         end;
      end;
   end;
end;

end.
 